import gleam/dynamic.{type Decoder}
import gleam/http/request.{type Request}
import gleam/http/response.{type Response}
import gleam/httpc
import gleam/json
import gleam/result

import apkallone.{type Client, type Error}

pub fn prepare_request(
  client: Client,
  endpoint: String,
) -> Result(Request(String), Error) {
  use req <- result.try(
    request.to(client.instance <> endpoint)
    |> result.replace_error(apkallone.BadInstance),
  )

  req
  |> request.prepend_header("user-agent", apkallone.user_agent)
  |> Ok
}

pub fn send_request(req: Request(String)) -> Result(Response(String), Error) {
  httpc.send(req)
  |> result.map_error(apkallone.FetchError)
}

pub fn decode_response(
  res: Response(String),
  decoder: Decoder(a),
) -> Result(a, Error) {
  res.body
  |> json.decode(decoder)
  |> result.map_error(apkallone.DecodeError)
}
