import gleam/dynamic.{type DecodeError, type Dynamic}

// TODO
pub type Instance {
  Instance(
    domain: String,
    title: String,
    version: String,
    description: String,
    usage: Usage,
  )
}

pub type Usage {
  Usage(users: Users)
}

pub type Users {
  Users(active_month: Int)
}

pub fn decode(dynamic: Dynamic) -> Result(Instance, List(DecodeError)) {
  dynamic
  |> dynamic.decode5(
    Instance,
    dynamic.field("domain", dynamic.string),
    dynamic.field("title", dynamic.string),
    dynamic.field("version", dynamic.string),
    dynamic.field("description", dynamic.string),
    dynamic.field("usage", decode_usage),
  )
}

fn decode_usage(dynamic: Dynamic) -> Result(Usage, List(DecodeError)) {
  dynamic
  |> dynamic.decode1(Usage, dynamic.field("users", decode_users))
}

fn decode_users(dynamic: Dynamic) -> Result(Users, List(DecodeError)) {
  dynamic
  |> dynamic.decode1(Users, dynamic.field("active_month", dynamic.int))
}
